=== debian/changelog ===
sirikali (1.6.0-1) unstable; urgency=medium

  * New upstream version.

 -- David Steele <steele@debian.org>  Wed, 03 Jul 2024 19:38:07 -0400
